/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic startup code for a Juce application.

  ==============================================================================
*/

#include "PluginProcessor.h"
#include "PluginEditor.h"


//==============================================================================
AudioClockAudioProcessor::AudioClockAudioProcessor()
{
	Measure = 6;
}

AudioClockAudioProcessor::~AudioClockAudioProcessor()
{
}

//==============================================================================
const String AudioClockAudioProcessor::getName() const
{
    return JucePlugin_Name;
}

int AudioClockAudioProcessor::getNumParameters()
{
    return 1;
}

float AudioClockAudioProcessor::getParameter (int index)
{
	return (float)Measure/30.0;
}

void AudioClockAudioProcessor::setParameter (int index, float newValue)
{
	
	switch (index)
	{
    	case PMeasure:
        	Measure= roundf(newValue*(30));
        	UiUpdateFlag = true;
        	break;
	
	default:
		break;
	}
}

const String AudioClockAudioProcessor::getParameterName (int index)
{
	switch (index)
	{
	case PMeasure:     return "Time Signature"; break;
	
	default:           return String::empty; break;
	}
	
}

const String AudioClockAudioProcessor::getParameterText (int index)
{
    return String::empty;
}

const String AudioClockAudioProcessor::getInputChannelName (int channelIndex) const
{
    return String (channelIndex + 1);
}

const String AudioClockAudioProcessor::getOutputChannelName (int channelIndex) const
{
    return String (channelIndex + 1);
}

bool AudioClockAudioProcessor::isInputChannelStereoPair (int index) const
{
    return true;
}

bool AudioClockAudioProcessor::isOutputChannelStereoPair (int index) const
{
    return true;
}

bool AudioClockAudioProcessor::acceptsMidi() const
{
   #if JucePlugin_WantsMidiInput
    return true;
   #else
    return false;
   #endif
}

bool AudioClockAudioProcessor::producesMidi() const
{
   #if JucePlugin_ProducesMidiOutput
    return true;
   #else
    return false;
   #endif
}

bool AudioClockAudioProcessor::silenceInProducesSilenceOut() const
{
    return false;
}

double AudioClockAudioProcessor::getTailLengthSeconds() const
{
    return 0.0;
}

int AudioClockAudioProcessor::getNumPrograms()
{
    return 1;
}

int AudioClockAudioProcessor::getCurrentProgram()
{
    return 0;
}

void AudioClockAudioProcessor::setCurrentProgram (int index)
{
}

const String AudioClockAudioProcessor::getProgramName (int index)
{
    return String::empty;
}

void AudioClockAudioProcessor::changeProgramName (int index, const String& newName)
{
}

//==============================================================================
void AudioClockAudioProcessor::prepareToPlay (double sampleRate, int samplesPerBlock)
{
    // Use this method as the place to do any pre-playback
		

    // initialisation that you need..
}

void AudioClockAudioProcessor::releaseResources()
{
    // When playback stops, you can use this as an opportunity to free up any
    // spare memory, etc.
}

void AudioClockAudioProcessor::processBlock (AudioSampleBuffer& buffer, MidiBuffer& midiMessages)
{
	AudioPlayHead::CurrentPositionInfo ActualTime;
	getPlayHead()->getCurrentPosition(ActualTime);
    int InputChannels=getNumInputChannels();
    int OutputChannels=getNumOutputChannels();
	// In case we have more outputs than inputs, this code clears any output
    // channels that didn't contain input data, (because these aren't
    // guaranteed to be empty - they may contain garbage).
    // I've added this to avoid people getting screaming feedback
    // when they first compile the plugin, but obviously you don't need to
    // this code if your algorithm already fills all the output channels.
    for (int i = InputChannels; i < OutputChannels; ++i)
        buffer.clear (i, 0, buffer.getNumSamples());

    // This is the place where you'd normally do the guts of your plugin's
    // audio processing...
    for (int channel = 0; channel < OutputChannels; ++channel)
    {
        float* channelData = buffer.getWritePointer (channel);
		long i;

        // ..do something to the data...
		if ((ActualTime.isPlaying)||(ActualTime.isRecording)){
			
			double SR = getSampleRate();
			//if (SR == 0)SR = 48000;
			const double SamplesPer96th = (60.0f / ActualTime.bpm*SR)/24.0;
			const double SamplesFromNext96th = ((fmod(ActualTime.ppqPosition, 1.0 / 24.0)/(1.0/24.0))*SamplesPer96th);
			const int PulseWidth = PULSE_LENGTH / 1000 * SR;

			double NoOfTicks;
			double SamplesPerTimeSignatur;
			double SamplesFromNextBar;
			double BarCounter;
			if (ClockValid == 0){
				NoOfTicks = 12*(Measure + 2);
				SamplesPerTimeSignatur = SamplesPer96th * NoOfTicks;
				SamplesFromNextBar = (fmod(ActualTime.ppqPosition, 1.0 / 24.0 * NoOfTicks) / (1.0 / 24.0 * NoOfTicks))*SamplesPerTimeSignatur;

				BarCounter = SamplesFromNextBar;

			/*	for (i = 0; i < buffer.getNumSamples(); i++){
					double ModCounterBar = fmod(BarCounter, SamplesPerTimeSignatur);
					if ((int)ModCounterBar == 0)ClockValid = 1;
					BarCounter += 1;
				}*/
					
			}

			//if (ClockValid == 1){
				double SampleCounter = SamplesFromNext96th;
				char FastPulse = 0;
				for (i = 0; i < buffer.getNumSamples(); i++){
					if (ClockValid == 0){
						double ModCounterBar = fmod(BarCounter, SamplesPerTimeSignatur);
						if ((int)ModCounterBar == 0)ClockValid = 1;
						BarCounter += 1;
					}

					if (ClockValid == 1){
						double ModCounter = fmod(SampleCounter, SamplesPer96th);
						if (ModCounter < PulseWidth){
							channelData[i] = 1.0f;

						}
						else {
							if (FastPulse == 0){
								channelData[i] = 0.0f;
								FastPulse = 1;
							}
							else{
								channelData[i] = 0.01f;
								FastPulse = 0;
							}
						}
					}

					SampleCounter += 1;
				}
			//}
			
		}
		else{
			ClockValid = 0;
            char FastPulse = 0;
            for (i = 0; i < buffer.getNumSamples(); i++){
                if (FastPulse == 0){
                    channelData[i] = 0.0f;
                    FastPulse = 1;
                }
                else{
                    channelData[i] = 0.01f;
                    FastPulse = 0;
                }
            }
		}
		
    }
}

//==============================================================================
bool AudioClockAudioProcessor::hasEditor() const
{
    return true; // (change this to false if you choose to not supply an editor)
}

AudioProcessorEditor* AudioClockAudioProcessor::createEditor()
{
    return new AudioClockEditor (this);
}

//==============================================================================
void AudioClockAudioProcessor::getStateInformation (MemoryBlock& destData)
{
    // You should use this method to store your parameters in the memory block.
    // You could do that either as raw data, or use the XML or ValueTree classes
    // as intermediaries to make it easy to save and load complex data.
	destData.setSize(1, false);
	destData.insert((void *)&Measure, 1, 0);
}

void AudioClockAudioProcessor::setStateInformation (const void* data, int sizeInBytes)
{
    // You should use this method to restore your parameters from this memory block,
    // whose contents will have been created by the getStateInformation() call
	unsigned char TEST[1];
	memcpy(TEST, data, 1);
	Measure = TEST[0];
    
    UiUpdateFlag = true;
	
	
	
}

//==============================================================================
// This creates new instances of the plugin..
AudioProcessor* JUCE_CALLTYPE createPluginFilter()
{
    return new AudioClockAudioProcessor();
}
